// Config.h
// Generado por GameConfig de la churrera
// Copyleft 2010 The Mojon Twins

// ============================================================================
// I. Configuracin general del juego
// ============================================================================

// En esta seccin configuramos las dimensiones del mapa, pantalla y posicin iniciales,
// pantalla y posicin finales (si aplica), nmero de objetos que hay que recoger, etctera.

#define MAP_W                   5       //
#define MAP_H                   5       // Dimensiones del mapa, en pantallas.
#define SCR_INICIO              20      // Pantalla de inicio
#define PLAYER_INI_X            2       //
#define PLAYER_INI_Y            2       // Coordenadas de inicio del jugador, a nivel de tiles
#define SCR_FIN                 99      // Pantalla del final. 99 si da igual.
#define PLAYER_FIN_X            99      //
#define PLAYER_FIN_Y            99      // Posicin del jugador para terminar, a nivel de tiles
#define PLAYER_NUM_OBJETOS      16      // Nmero de objetos para terminar el juego
#define PLAYER_LIFE             66      // Vida mxima (con la que empieza, adems)
#define PLAYER_REFILL           10      // Recarga de vida.

// ============================================================================
// II. Tipo de motor
// ============================================================================

// En esta seccin definimos el tipo de motor que ser compilado con el juego. En esta 
// versin 2.0 tenemos dos tipos bsicos y excluyentes: top-view (MOGGY_STYLE) y de plataformas.
// Para emplear uno u otro deberemos descomentarlo eliminando las marcas /* y */ de principio
// y fin de bloque.

// En la versin 3 se aade el motor de disparos, en principio compatible con el de plataformas,
// Pero prximamente compatible con el moggy style tambin. En pruebas: el motor de scripting.

// Motor top-view (MOGGY-STYLE)

//#define PLAYER_MOGGY_STYLE              // Vista cenital, movimiento 8-way
#define PLAYER_AUTO_CHANGE_SCREEN       // Si se define, se cambiar de pantalla sin pulsar una direccin.

// Motor de plataformas

#define PLAYER_HAS_JUMP                 // Si se define, el personaje principal SALTA
//#define PLAYER_HAS_JETPAC             // Si se define, el personaje principal tiene JET PAC
//#define PLAYER_KILLS_ENEMIES          // Si se define, el personaje mata enemigos saltando sobre ellos

// Los siguientes defines pueden aplicarse a cualquiera de los dos tipos de motores y definen
// comportamiento extra:

//#define PLAYER_PUSH_BOXES             // Si se define, el jugador podr empujar los tiles #14
#define DIRECT_TO_PLAY                  // Si se define, la pantalla de marco y la de ttulo son la misma
#define DEACTIVATE_KEYS                 // Si se define, desactiva las llaves automticas
//#define DEACTIVATE_OBJECTS            // Si se define, desactiva los objetos automticos.
#define DEACTIVATE_EVIL_TILE            // Si se define, desactiva los tiles que te matan (1)
#define PLAYER_BOUNCES                  // Si se define, la colisin hace que el jugador rebote.
//#define PLAYER_FLICKERS               // Si se define, la colisin activa inmunidad

// Motor de disparos
#define PLAYER_CAN_FIRE                 // Si se define, el jugador salta con ARRIBA y dispara con FIRE
#define PLAYER_BULLET_SPEED     8       // Pixels/frame. 
#define MAX_BULLETS             3       // Nmero de balas. No te vaya col.
#define PLAYER_BULLET_Y_OFFSET  4       // Pxels con respecto a la posicin Y del jugador
#define ENEMIES_LIFE_GAUGE      5       // Tiros que hay que darles pa matarlos

#define RANDOM_RESPAWN                  // Si se define, se activan los enemigos voladores.
#define FANTY_MAX_V             256     // Velocidad mxima de fantys.
#define FANTY_A                 12      // Aceleracin de fantys
#define FANTIES_LIFE_GAUGE      10      // Tiros que hay que darles pa matarlos

// Scripting
//#define ACTIVATE_SCRIPTING            // Para activar el msc

// ============================================================================
// III. Configuracin de la pantalla
// ============================================================================

// En esta seccin colocamos los elementos en la pantalla: la ventana de juego y los tres
// marcadores (vida, objetos y llaves) definiendo su posicin a nivel de carcteres.
// Tambin definimos si queremos sombreado automtico (los tiles obstculo dejan sombra sobre
// los de segundo plano), y de qu tipo:

#define VIEWPORT_X              1       //
#define VIEWPORT_Y              0       // Posicin de la ventana de juego (en carcteres)
#define LIFE_X                  7       //
#define LIFE_Y                  21      // Posicin del marcador de vida (en carcteres)
#define OBJECTS_X               16      //
#define OBJECTS_Y               21      // Posicin del marcador de objetos (en carcteres)
#define KEYS_X                  10      //
#define KEYS_Y                  21      // Posicin del marcador de llaves (en carcteres)
#define KILLED_X                27      //
#define KILLED_Y                21      // Posicin del marcador de enemigos matados (en carcteres)

// Efectos grficos: Descomentar la que aplique, o ninguna.

//#define USE_AUTO_SHADOWS              // Sombras automticas por atributos
//#define USE_AUTO_TILE_SHADOWS         // Sombras automticas por tiles-
#define UNPACKED_MAP                    // Mapa sin comprimir (256 tiles). Las sombras NO TIENEN EFECTO
#define NO_MASKS                        // Si se define, sprites con OR.
#define PLAYER_ALTERNATE_ANIMATION      // Si se define, los frames van 1, 2, 3, 1, 2, 3, ...

// ============================================================================
// IV. Configuracin del movimiento del jugador
// ============================================================================

// En esta seccin definimos las constantes que gobiernan los parmetros del motor de movimiento.
// En un juego tipo plataformas, definimos por separado el comportamiento en vertical y el compor-
// tamiento en horizontal. Para un juego tipo top-view, los valores definidos en el comportamiento
// horizontal se aplican tambin al vertical.

// IV.1. Movimiento vertical, slo aplicable al motor de plataformas:

#define PLAYER_MAX_VY_CAYENDO   512     // Velocidad mxima cuando cae (512/64 = 8 pxels/frame)
#define PLAYER_G                32      // Aceleracin de la gravedad (32/64 = 0.5 pxeles/frame^2)

#define PLAYER_VY_INICIAL_SALTO 64      // Velocidad inicial al saltar (64/64 = 1 pxel/frame)
#define PLAYER_MAX_VY_SALTANDO  256     // Velocidad mxima al saltar (320/64 = 5 pxels/frame)
#define PLAYER_INCR_SALTO       32      // Aceleracin al pulsar "salto" (48/64 = 0.75 pxeles/frame^2)

#define PLAYER_INCR_JETPAC      32      // Incremento al usar el jetpac
#define PLAYER_MAX_VY_JETPAC    256     // Mxima velocidad vertical con jetpac

// IV.2. Movimiento horizontal (en motor de plataformas) o general (en motor top-view):

#define PLAYER_MAX_VX           256     // Velocidad mxima horizontal (192/64 = 3 pxels/frame)
#define PLAYER_AX               24      // Aceleracin horizontal (24/64 = 0,375 pxels/frame^2)
#define PLAYER_RX               24      // Friccin horizontal (32/64 = 0,5 pxels/frame^2)

// ============================================================================
// V. Comportamiento de los tiles
// ============================================================================

// Indica el comportamiento de cada uno de los 16 tiles. Recuerda que el tile n 15 (el ltimo)
// es el cerrojo y debe ser un obstculo, porque si no, vaya mierda de cerrojo.

// 0 = traspasable.
// 1 = traspasable y mata.
// 2 = traspasable y oculta.
// 4 = plataforma
// 8 = obstculo

#ifndef UNPACKED_MAP
// Comportamiento de los tiles para mapas "packed"
unsigned char comportamiento_tiles [] = {
    0, 0, 0, 0, 8, 8, 8, 8, 0, 8, 0, 0, 1, 8, 8, 8
};
#else
// Comportamiento de los tiles en mapas "unpacked"
unsigned char comportamiento_tiles [] = {
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 0,
    0, 0, 4, 8, 8, 4, 8, 8, 4, 4, 8, 0, 0, 2, 0, 0,
    0, 0, 4, 4, 0, 8, 2, 2, 2, 2, 8, 0, 2, 2, 2, 8  
};
#endif
